/* Reflow Oven Controller
*
* Copyright (C) 2020  Mario Hüttel <mario.huettel@gmx.net>
*
* This file is part of the Reflow Oven Controller Project.
*
* The reflow oven controller is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License version 2 as
* published by the Free Software Foundation.
*
* The Reflow Oven Control Firmware is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the reflow oven controller project.
* If not, see <http://www.gnu.org/licenses/>.
*/

#include <reflow-controller/stack-check.h>
#include <stdint.h>

extern char __ld_top_of_stack;
extern char __ld_eheap;

int32_t stack_check_get_usage()
{
	uint32_t stack_top;
	uint32_t stack_ptr;

	stack_ptr = read_stack_pointer();
	stack_top = (uint32_t)&__ld_top_of_stack;

	return stack_top - stack_ptr;
}

int32_t stack_check_get_free()
{
	uint32_t upper_heap_boundary;
	uint32_t stack_ptr;

	stack_ptr = read_stack_pointer();
	upper_heap_boundary = (uint32_t)&__ld_eheap;

	return stack_ptr - upper_heap_boundary;
}
